<template>
  <MainTemplate>
    <template #topBar>
      <div class="flex flex-row items-center justify-between pt-5 pb-3 px-7">
        <h1 class="font-bold text-xl h-8">Qualifikationen</h1>
      </div>
    </template>
    <template #diffMain>
      <div class="flex flex-col gap-4 grow pl-7">
        <div class="flex flex-col gap-2 grow overflow-y-scroll pr-7">
          <QualificationListItem
            v-for="qualification in qualifications"
            :key="qualification.id"
            :qualification="qualification"
          />
        </div>
        <div class="flex flex-row gap-4">
          <button v-if="can('create', 'settings', 'qualification')" primary class="!w-fit" @click="openCreateModal">
            Qualifikation erstellen
          </button>
        </div>
      </div>
    </template>
  </MainTemplate>
</template>

<script setup lang="ts">
import { defineComponent, defineAsyncComponent, markRaw } from "vue";
import { mapState, mapActions } from "pinia";
import MainTemplate from "@/templates/Main.vue";
import { useQualificationStore } from "@/stores/admin/qualification";
import QualificationListItem from "@/components/admin/settings/qualification/QualificationListItem.vue";
import { useModalStore } from "@/stores/modal";
import { useAbilityStore } from "@/stores/ability";
</script>

<script lang="ts">
export default defineComponent({
  computed: {
    ...mapState(useQualificationStore, ["qualifications"]),
    ...mapState(useAbilityStore, ["can"]),
  },
  mounted() {
    this.fetchQualifications();
  },
  methods: {
    ...mapActions(useQualificationStore, ["fetchQualifications"]),
    ...mapActions(useModalStore, ["openModal"]),
    openCreateModal() {
      this.openModal(
        markRaw(
          defineAsyncComponent(() => import("@/components/admin/settings/qualification/CreateQualificationModal.vue"))
        )
      );
    },
  },
});
</script>
